#include <GUIConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>

Global $UPD = "Pfad zur Update.upd auf dem Server"
Global $VER = @ScriptDir & "\Version.ver" ;Pfad zur lokalen Versionsdatei
Global $Program = @ScriptDir & "\Programm.exe" ;Pfad zum eigentlichen Programm

$Updater = GUICreate("Updater", 253, 67, 192, 124)
$Update = GUICtrlCreateButton("Update", 8, 8, 75, 49, $WS_GROUP)
$Start = GUICtrlCreateButton("Start", 88, 8, 75, 49, $WS_GROUP)
$Beenden = GUICtrlCreateButton("Beenden", 168, 8, 75, 49, $WS_GROUP)
GUISetState()

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $Beenden
			Exit
		Case $Start
			_Start()
		Case $Update
			_Update()
	EndSwitch
WEnd

Func _Update()
	$VersionNew = StringSplit(BinaryToString(InetRead($UPD)), ";")
	$VersionOld = FileRead($VER)
	If $VersionNew[1] > $VersionOld Then
		$Size = InetGetSize($VersionNew[3])
		$InetGet = InetGet($VersionNew[3], $Program, 0, 1)
		If @error <> 0 Then
		    MsgBox(16, "Fehler", "Update konnte nicht heruntergeladen werden. Bitte berprfen sie ihre Internetverbindung.")
		Else
			ProgressOn("Updater", "Fortschritt:", "0%")
			Do
				ProgressSet(InetGetInfo($InetGet, 0) * 100 / $Size, InetGetInfo($InetGet) * 100 / $Size & "%")
				Sleep(100)
			Until $Size = InetGetInfo($InetGet, 0)
			$File = FileOpen($VER)
			FileWrite($File, $VersionNew[1])
			FileClose($File)
			_Start()
		EndIf
	Else
		If MsgBox(68, "Updater", "Ihre Version " & $VersionNew[2] & " ist bereits aktuell. Programm starten?") = 6 Then
		    _Start()
		Else
			GUIDelete()
			Exit
		EndIf
	EndIf
EndFunc

Func _Start()
	If Run($Program) = 0 Then
		If MsgBox(20, "Fehler", "Die Anwendung konnte nicht gestartet werden. Stellen sie sicher, dass sie sich im selben Verzeichnis befindet. Erneut versuchen?") = 6 Then _Start()
	Else
		GUIDelete()
		Exit
	EndIf
EndFunc
